OBJ

  ser   : "Full-Duplex_COMEngine 3"
   
CON

  XB_Tx=               30'24             'Transmit pin(to Xbee Din)
  XB_Rx=               31'25             'Receive pin (from Xbee Dout)
  XB_Baud=             115200            'Communication baud rate

  max_frame_data_size= 283

VAR

word tx_packet_length
word rx_packet_length

DAT
     api_TX_packet  byte $0[max_frame_data_size],0        '283 should be fine.
     api_RX_packet  byte $0[max_frame_data_size],0        '283 should be fine.
     
PUB Start

     ser.COMEngineStart(XB_Rx,XB_Tx,XB_Baud)'(RXpin, TXpin, Baud)   

PUB Stop

pub network_discover( location , qty ) | packet_id , i
{
Network Discover. Discovers and reports all RF modules found. The following
information is reported for each module discovered.

MY<CR> (always 0xFFFE)

SH<CR>

SL<CR>

NI<CR> (Variable length)

PARENT_NETWORK ADDRESS<CR> (2 Bytes) (always 0xFFFE)

DEVICE_TYPE<CR> (1 Byte: 0=Coord, 1=Router, 2=End Device)

STATUS<CR> (1 Byte: Reserved)

PROFILE_ID<CR> (2 Bytes)

MANUFACTURER_ID<CR> (2 Bytes)

DIGI DEVICE TYPE<CR> (4 Bytes. Optionally included based on NO settings.)

RSSI OF LAST HOP<CR> (1 Byte. Optionally included based on NO settings.)

<CR>

After (NT * 100) milliseconds, the command ends by returning a <CR>. ND also accepts
a Node Identifier (NI) as a parameter (optional). In this case, only a module that
matches the supplied identifier will respond.

If the ND command is sent through a local API frame, each response is returned as a
separate Local or Remote AT Command Response API packet, respectively. The data
consists of the above listed bytes without the carriage return delimiters. The NI string
will end in a "0x00" null character.
}
     packet_ID := type_08_query( string("ND") )

     if type_88_read( packet_ID ) == 0               '

          get_node_info(location)

     else

          return -1

     repeat qty-1
          
          if  type_97_read( packet_ID ) == 0   

               location += 44

               get_node_info( location )
                
               
pri get_node_info( location ) | i ,size
          
               'MY
               byte[location+0] := byte[@api_rx_packet+8]
               byte[location+1] := byte[@api_rx_packet+9]
               'SH
               byte[location+2] := byte[@api_rx_packet+10]        
               byte[location+3] := byte[@api_rx_packet+11]
               byte[location+4] := byte[@api_rx_packet+12]
               byte[location+5] := byte[@api_rx_packet+13]
               'SL
               byte[location+6] := byte[@api_rx_packet+14]        
               byte[location+7] := byte[@api_rx_packet+15]
               byte[location+8] := byte[@api_rx_packet+16]
               byte[location+9] := byte[@api_rx_packet+17]

               'NI
               size := strsize(@api_rx_packet+18)
               bytemove( byte[location+10] , @api_rx_packet+18 , size)

               'PNA
               byte[location+30] := byte[@api_rx_packet+18+size]
               byte[location+31] := byte[@api_rx_packet+19+size]

               'DT
               byte[location+32] := byte[@api_rx_packet+20+size]

               'ST
               byte[location+33] := byte[@api_rx_packet+21+size]

               'Prof
               byte[location+34] := byte[@api_rx_packet+22+size] 
               byte[location+35] := byte[@api_rx_packet+23+size] 

               'Man
               byte[location+36] := byte[@api_rx_packet+24+size] 
               byte[location+37] := byte[@api_rx_packet+25+size] 
               
               'DDT
               byte[location+38] := byte[@api_rx_packet+26+size] 
               byte[location+39] := byte[@api_rx_packet+27+size] 
               byte[location+40] := byte[@api_rx_packet+28+size] 
               byte[location+41] := byte[@api_rx_packet+29+size] 

               'RSSI
               byte[location+42] := byte[@api_rx_packet+30+size]               

pub type_08_query(command)| i , checksum_byte 
{

Local AT Command- query only, no values.
This packet queries the local xbee.
It will respond with a type 88 packet.
Read the response using
type_88_read_string(ID)

Parameters:
     command   The two ASCII character AT command 

}
                                           
     build_0_3_4( $08 )              
    
     bytemove( @api_TX_packet[5], command , 2 )

     checksum_byte := 0                      

     repeat i from 3 to 6

          checksum_byte += api_TX_packet[i]

     api_TX_packet[7]:= $FF - checksum_byte           

     build_length( 7 )                       
                 
     send_packet( 7 )                         

     '*** Writing this packet should cause a type 88 packet to be received.
     
     return api_TX_packet[4] 'Return the packet ID of this packet
     
pub type_08_write_val( command , highest , high , low , lowest  )| i , checksum_byte  
{
Local AT Command- with parameter value.
This packet writes to the local xbee.
It will respond with a type 88 packet.
Read the response using
type_88_read_string(ID)

Parameters:
     command   The two ASCII character AT command 
     highest   highest 4 bytes of the value to send
      lowest   lowest 4 bytes of the value to send

     *AT Commands such as AF use up to 8 bytes
     *AT Commands such as KY use up to 16 bytes (128 bit)
}

     build_0_3_4( $08 )                 
   
     bytemove( @api_TX_packet[5] , command , 2 )
     
     build_value( highest , high , low , lowest , 7 )
     
     checksum_byte := 0                        

     repeat i from 3 to 26

          checksum_byte += api_TX_packet[i]

     api_TX_packet[27] := $FF - checksum_byte              

     build_length( 27 )                           

     send_packet( 27 ) 

     '*** Writing this packet should cause a type 88 packet to be received.
     
     return api_TX_packet[4] 'Return the packet ID of this packet
     
pub type_08_write_string(command , stringvalue )| i , size , checksum_byte
{
Local AT Command- with ASCII string value.
This packet writes to the local xbee.
It will respond with a type 88 packet.
Read the response using
type_88_read_string(ID)

Parameters:
     command        The two ASCII character AT command 
     stringvalue    The string value to send

     *AT Commands such as DN use up to a 20 byte ASCII string.
}
     build_0_3_4( $08 )                   
      
     bytemove( @api_TX_packet[5] , command , 2 )

     'size := Add_Buffer( stringvalue , @api_TX_packet[7] )

     size:=strsize(stringvalue)
     bytemove(@api_TX_packet[7],stringvalue,size)
     
     checksum_byte := 0                          

     repeat i from 3 to 6 + size

          checksum_byte += api_TX_packet[i]

     api_TX_packet[7 + size] := $FF - checksum_byte              

     build_length( 7 + size )                       
  
     send_packet( 7 + size )

     '*** Writing this packet should cause a type 88 packet to be received.
     
     return api_TX_packet[4] 'Return the packet ID of this packet
     
pub type_10_request( address , radius , options , data )| i , size , checksum_byte
{
Transmit request.
This packet sends data to a remote.
The local xbee will respond with a type 8B packet.
The type_8B_read(api_TX_packet[4]) reads the response
received from the local xbee concerning the delivery
status of this packet.

Parameters:
     address   The 8 byteIaddress of the remote xbee 
     radius    Max # of hops for broadcast (0=use max hops value)
     options   See manual
     data      The rf data to send
     *rf data size is limited to 256 bytes
}


     build_0_3_4($10)
     
     bytemove( @api_TX_packet[5] , address , 8 )
     
     api_TX_packet[13] := $FF                    
     
     api_TX_packet[14] := $FE

     api_TX_packet[15] := radius

     api_TX_packet[16] := options

     'size:=add_buffer(data , @api_TX_packet[17] ) 

     size:=strsize(data)
     bytemove(@api_TX_packet[17],data,size)
     
     checksum_byte := 0                          

     repeat i from 3 to 16 + size

          checksum_byte += api_TX_packet[i]

     api_TX_packet[17 + size] := $FF - checksum_byte           

     build_length(17 + size)                        
  
     send_packet(17 + size)                        

     '*** Writing this packet should cause a type 8B packet to be received.
     
     return api_TX_packet[4] 'Return the packet ID of this packet

pub type_11_request(address , src , dest , clust , prof , radius , options , data)| i , size , checksum_byte
{
Explicit Transmit request.
This packet sends data to a remote.
The local xbee will respond with a type 8B packet.
The type_8B_read(api_TX_packet[4]) reads the response
received from the local xbee concerning the delivery
status of this packet.

Parameters:
     address   The 8 byteIaddress of the remote xbee 
     src       The source endpoint
     dest      The destination endpoint
     clust     The cluster ID
     prof      The profile ID
     radius    Max # of hops for broadcast (0=use max hops value)
     options   See manual
     data      The rf data to send
     *rf data size is limited to 256 bytes
}

     build_0_3_4($11)
     
     bytemove( @api_TX_packet[5] , address , 8 )       

     api_TX_packet[13] := $FF                   
     
     api_TX_packet[14] := $FE

     api_TX_packet[15] := src

     api_TX_packet[16] := dest

     api_TX_packet[17] := byte [@clust + 1]

     api_TX_packet[18] := byte [@clust + 0]

     api_TX_packet[19] := byte [@prof + 1]

     api_TX_packet[20] := byte [@prof + 0]

     api_TX_packet[21] := radius

     api_TX_packet[22] := options
          
     'size := add_buffer( data , @api_TX_packet[23] ) 

     size:=strsize(data)
     bytemove(@api_TX_packet[23],data,size)
         
     checksum_byte := 0                         

     repeat i from 3 to 22 + size

          checksum_byte += api_TX_packet[ i ]

     api_TX_packet[ 23 + size ] := $FF - checksum_byte           

     build_length( 23 + size )                        
  
     send_packet( 23 + size )                       

     '*** Writing this packet should cause a type 8B packet to be received.
     
     return api_TX_packet[4] 'Return the packet ID of this packet
     
pub type_17_query( address , command )| i , checksum_byte             'Remote AT Command (query only)
{
Remote AT Command- query only.
This packet sends an AT Command to a remote xbee.
The remote xbee will respond with a type 97 packet.
This response packet will tell us the parameter of
the AT command we queried, as well as whether
the query was successful.

Parameters:
     address   The 8 byteIaddress of the remote xbee 
     command   The AT command to query
}
     build_0_3_4( $17 )                 
  
     bytemove( @api_TX_packet[5], address , 8 )        'Fill in bytes [5] to [12] with the destination address

     api_TX_packet[13] := $FF                          'byte [13] and [14] are reserved. Set to $FFFE
     
     api_TX_packet[14] := $FE
                                                  
     api_TX_packet[15] := $0                           'Don't apply changes
  
     bytemove( @api_TX_packet[16], command , 2 ) 

     checksum_byte := 0                                'Calculate the checksum here.

     repeat i from 3 to 17

          checksum_byte += api_TX_packet[i]

     api_TX_packet[18] := $FF - checksum_byte          'Fill in the checksum value at the appropriate byte.     

     build_length(18)                                  'Fill in the length at bytes [1] and [2]
  
     send_packet(18)                                   'Send the packet.

     '*** Writing this packet should cause a type 97 packet to be received.
     
     return api_TX_packet[4] 'Return the packet ID of this packet

pub type_17_write_val(address , command , highest , high , low , lowest )| i , checksum_byte   'Remote AT Command (with value)
{
Remote AT Command- with value.
This packet sends an AT Command to a remote xbee.
The remote xbee will respond with a type 97 packet.
This response packet will tell us the parameter of
the AT command we changed, as well as whether
the query was successful.

Parameters:
     address   The 8 byteIaddress of the remote xbee 
     command   The AT command to query
     highest   highest 4 bytes of the value to send
      lowest   lowest 4 bytes of the value to send
}
     build_0_3_4($17)                   
  
     bytemove( @api_TX_packet[5], address , 8 )        'Fill in bytes [5] to [12] with the destination address

     api_TX_packet[13] := $FF                          'byte [13] and [14] are reserved. Set to $FFFE
     
     api_TX_packet[14] := $FE
                                                  
     api_TX_packet[15] := $02

     bytemove( @api_TX_packet[16], command , 2 )       'Fill in bytes [16] and [17] of the packet:  AT command (PL, BD, etc)

     build_value(highest,high,low,lowest,18)           'Fill in bytes [18] to [33] with the value for the AT command
                'msb                  lsb              'some AT commands can use up to 16 bytes for values
      
     checksum_byte:= 0                                 'Calculate the checksum here.

     repeat i from 3 to 33

          checksum_byte += api_TX_packet[i]

     api_TX_packet[34] := $FF - checksum_byte          'Fill in the checksum value at the appropriate byte.     

     build_length(34)                                  'Fill in the length at bytes [1] and [2]
  
     send_packet(34)                                   'Send the packet.

     '*** Writing this packet should cause a type 97 packet to be received.
     
     return api_TX_packet[4] 'Return the packet ID of this packet
     
pub type_17_write_string(address , command , stringvalue )|i , size , checksum_byte       'Remote AT Command (with string)
{
Remote AT Command- with ASCII string.
This packet sends an AT Command to a remote xbee.
The remote xbee will respond with a type 97 packet.
This response packet will tell us the parameter of
the AT command we changed, as well as whether
the query was successful.

Parameters:
     address        The 8 byteIaddress of the remote xbee 
     command        The AT command to query
     stringvalue    The string to send
}
     build_0_3_4($17)                   
                                                 
     bytemove( @api_TX_packet[5], address , 8 )        'Fill in bytes [5] to [12] with the destination address

     api_TX_packet[13] := $FF                          'byte [13] and [14] are reserved. Set to $FFFE
     
     api_TX_packet[14] := $FE
                                                  
     api_TX_packet[15] := $02

     bytemove( @api_TX_packet[16], command , 2 )       'Fill in bytes [16] and [17] of the packet:  AT command (PL, BD, etc)
               
     'size := Add_Buffer(stringvalue , @api_TX_packet[18]) 'Put the string in the at_string buffer and get it's size

     size:=strsize(stringvalue)
     bytemove(@api_TX_packet[18],stringvalue,size) 

     checksum_byte:= 0                                 'Calculate the checksum here.

     repeat i from 3 to 17 + size

          checksum_byte += api_TX_packet[i]

     api_TX_packet[18 + size] := $FF - checksum_byte   'Fill in the checksum value at the appropriate byte.     

     build_length(18 + size)                           'Fill in the length at bytes [1] and [2]
  
     send_packet(18 + size)                            'Send the packet.

     '*** Writing this packet should cause a type 97 packet to be received.
     
     return api_TX_packet[4] 'Return the packet ID of this packet
     
pub type_88_read(ID) | i                          'AT Command Response
{

When a type 08 packet (Local AT Command) is sent, the local
xbee returns this packet type.
This method returns the status of the 08 packet that was just sent.

     The least significant nibble of byte [7] indicates the command
     status:
     0 = OK
     1 = ERROR
     2 = Invalid Command
     3 = Invalid Parameter
}
     if NOT packet_received($88)

          return -1

     if ID <> api_rx_packet[4]

          return -1

     return $0000_0011 & api_rx_packet[7]

     'This method returns the command status (0 thru 3) if the packet Id matches
     'This method returns -1 if the packet Id is incorrect.
     'This method returns -1 if no packet is received.
     
pub type_8A_read                                  'Modem Status
{
 This packet is received any time the following occurs:
 It will return one of the following.
 
 0x00 = Hardware reset
 0x01= Watchdog timer reset
 0x0B = Network Woke Up
 0x0C = Network Went To Sleep
} 
     if NOT packet_received($8A)

          return -1
     
     return api_rx_packet[4]
          
     'This method returns -1 if no packet is received.
     
pub type_8B_read_delivery(ID)                     'Transmit Status Delivery
                                   
{
When a type 10 or 11 packet is sent
this packet type is received.
It returns the delivery status
of the type 10 or 11 packet
that was sent.
}


     if NOT packet_received($8B)

          return -1

     if ID <> api_rx_packet[4]

          return -1
               
     return api_rx_packet[8]

     'This method returns the delivery status of the previously sent type 10 or 11 packet.
     'This method returns -1 if the packet Id is incorrect.
     'This method returns -1 if no packet is received.
     
pub type_8B_read_discovery(ID)                    'Transmit Status Discovery
                                   
{
When a type 10 or 11 packet is sent
this packet type is received.
It returns the discovery status
of the type 10 or 11 packet
that was sent.
}


     if NOT packet_received($8B)

          return -1

     if ID <> api_rx_packet[4]

          return -1
               
     return api_rx_packet[9]

     'This method returns the discovery status of the previously sent type 10 or 11 packet.
     'This method returns -1 if the packet Id is incorrect.
     'This method returns -1 if no packet is received.
     
pub type_8D_read                                  'Route information packet
{
 Not sure I understand this one.

}
     if NOT packet_received($8D)

          return -1

     return 1

pub type_8E_read                                  'Aggregate Addressing Update
{
 Not sure I understand this one.

}
     if NOT packet_received($8E)

          return -1

     return 1
     
pub type_90_read                                  'RX Indicator
{
When the module receives an RF packet,
it is sent out the UART using this
packet type.
}
     if NOT packet_received($90)

          return -1

     return rx_packet_length

     'return the size of the rfdata packet
     
pub type_91_read                                  'Explicit Rx Indicator
{
When the modem receives an RF packet,
it is sent out the UART using this
packet type (when AO=1).
 }

     if NOT packet_received($91)

          return -1

     return rx_packet_length
           
pub type_95_read                                  'Node Identification Indicator
{
This frame is received when a module
transmits a node identification message
to identify itself (when AO=0).
The data portion of this frame
is similar to a network discovery
response frame (see ND command).
}

     if NOT packet_received($95)

          return -1
          
pub type_97_read(ID)                              'Remote Command Response
{
If a module receives a remote command
response RF data frame in response to a
Remote AT Command Request, the module
will send a Remote AT Command Response
message out the serial interface. Some
commands may send back multiple
frames--for example, Node Discover (ND) command.
}

     if NOT packet_received($97)

          return -1

     if ID <> api_rx_packet[4]

          return -1

pub packet_received(type) | i ,  checksum_byte

     if ser.receiverEmpty

          return -1
          
     repeat until ser.receiverEmpty

          api_rx_packet[0] := ser.readByte

          if api_rx_packet[0] == $7E

               rx_packet_length := ser.readShort                        

                    api_rx_packet[1] := byte[@rx_packet_length[1]]

                    api_rx_packet[2] := byte[@rx_packet_length[0]]

               ser.readData(@api_rx_packet[3],rx_packet_length+1)       

               checksum_byte := 0

               repeat i from 3 to 3 + rx_packet_length                 

                    checksum_byte += api_rx_packet[i]

               if checksum_byte <> $FF

                    return -1

               if type == api_rx_packet[3]

                    return api_rx_packet[3] 'Return the packet type received.

     return 0

     'This method returns the packet type if it's the correct one specified.
     'This method returns -1 if the checksum fails
     'This method returns 0 if the received packet is the wrong type.
           
pri build_0_3_4(type)

     empty_tx_packet                         'Empty the api_TX_packet
      
     api_TX_packet[0]:=$7E                   'set the start delimiter

     api_TX_packet[3]:=type                  'set the packet type

     api_TX_packet[4]:=get_frame_ID          'generate the frame ID

pri build_length(last)

  tx_packet_length:=last-3

  api_TX_packet[1]:=byte[@tx_packet_length[1]]

  api_TX_packet[2]:=byte[@tx_packet_length[0]]
  
'The length is always the number of bytes from byte[3] up to but NOT including the checksum byte.

pri build_value(highest,high,low,lowest,startbyte)

     repeat result from 0 to 12 step 4

          EndianSwap(@api_TX_packet + startbyte + result, @highest + result)

PRI EndianSwap(destinationPtr, sourcePtr)

     repeat result from 0 to 3
     
          byte[destinationPtr][result] := byte[sourcePtr][3 - result]
    
pri send_packet(count)|i
  
  repeat i from 0 to count
     ser.writeHex(api_TX_packet[i], 2)
  
  ser.writeByte(13)   'this is for testing in pst only!
  ser.writeByte(10)   'this is for testing in pst only!
 
pri get_frame_ID
    {
     frame_ID++

     If frame_ID => 255

          frame_ID := 1

     return frame_ID
     } return 1

pri empty_tx_packet
{
  Empty our api packet buffer.
}
    bytefill(@api_tx_packet, 0, max_frame_data_size)

pri empty_rx_packet
{
  Empty our api packet buffer.
}
    bytefill(@api_rx_packet, 0, max_frame_data_size)